// =============== Klassen-Definition: delta__MATRIX  ===================================
// delta_MATRIX-Klasse fuer 2D_delta(i,j)- und 4D_delta(i,j,k,l)-Matrix
// Indizierung von i,j,k,l beginnt bei 0 !!!
// delta-Matrizen werden spaltenweise gespeichert !!!
// 2D-Matrix kann fuer Diagonal-Matrix mit Faktor multipliziert werden !
// ======================================================================================
// Copyright: Univ.-Prof. Dr.-Ing. Udo F. Meissner, Darmstadt
// experimentelles Lehr- und Studienprogramm - kommerzielle Nutzung nicht gestattet
// Der Autor bernimmt keine Haftung fr Unvollstndigkeiten und Maengel der Algorithmen!
// Version:  2003
// Compiler: C++
// ================ Include-Files =======================================================
#include "pch.h"
#include "framework.h"
#include "MATRIXclass.h"
// ---------------------
#include "delta_Matrix.h"
#include "Matrix.h"
// ============================================================================
// public -> Oeffentliche Mitgliedsfunktionen
// ============================================================================
//
// Konstruktor -> 2D delta_MATRIX delta(ni,nj, faktor)
// =================================================== 
delta_MATRIX::delta_MATRIX(int ni, int nj, double faktor) : MATRIX(ni, nj)
{
	//
	//*** std::cerr<<"2D delta_MATRIX::Konstruktor: Einrichten von 2D delta_MATRIX"<<'\n'; 
	//
	int i, j;
	//
	if (ni == nj)
	for (j = 0; j < nj; j++)
		for (i = 0; i < ni; i++)
		{
			if (i == j) this->element(i, j) = faktor;
			//***  std::cerr << i << j << this->element(i, j) << '\n';
		}
	else
	{
		std::cout << "FEHLER => delta_Matrix 2. Stufe::Konstruktor: Dimension muss ni = nj sein !!! " << endl;
		std::cout << "FEHLER => delta_Matrix 2. Stufe:: ni= " << ni << " nj= " << nj << endl;
    };
}; //-------------------------------------------------------
// 
// Konstruktor -> 4D delta_MATRIX delta(faktor,ni,nj,nk,nl)
// ========================================================
delta_MATRIX::delta_MATRIX(int ni, int nj, int nk, int nl) : MATRIX(ni,nj,nk,nl)
{
//
//*** std::cerr<<"4D delta_MATRIX::Konstruktor: Einrichten von 4D delta_MATRIX"<<'\n'; 
// 
// int i,j,k,l;
// this->element(i, j, k, l) = e(i, j, s) * e(k, l, s) = d(i, k) * d(j, l) - d(i, l) * d(j, k);
//
	if (ni > 3 || nj > 3 || nk > 3 || nl > 3)
	{
     std::cout << "FEHLER => delta_MATRIX 4. Stufe::Konstruktor: Dimension muss ni = nj = nk = nl <= 3 sein !!! " << endl;
	 std::cout << "FEHLER => delta_MATRIX 4. Stufe:: ni= "<< ni <<" nj= "<< nj <<" nk= "<< nk <<" nl= "<< nl << endl;
	}
	else
	{
		if (ni > 1 && nj > 1 && nk > 1 && nl >> 1)
		{   // ni = nj = nk = nl >= 2
			if (ni == nj && nj == nk && nk == nl)
			{
				this->element(0, 1, 0, 1) =  1.0;
				this->element(0, 1, 1, 0) = -1.0;
				this->element(1, 0, 1, 0) =  1.0;
				this->element(1, 0, 0, 1) = -1.0;
			}
			else
			{
				std::cout << "FEHLER => delta_MATRIX 4. Stufe::Konstruktor: Dimension muss ni = nj = nk = nl sein !!! " << endl;
				std::cout << "FEHLER => delta_MATRIX 4. Stufe:: ni= " << ni << " nj= " << nj << " nk= " << nk << " nl= " << nl << endl;
			};
	    }
//
     	if (ni == 3 && nj == 3 && nk == 3 && nl == 3)
	    {   // 	ni = nj = nk = nl = 3
		this->element(2, 1, 2, 1) =  1.0;
		this->element(2, 1, 1, 2) = -1.0;
		this->element(1, 2, 1, 2) =  1.0;
		this->element(1, 2, 2, 1) = -1.0;
		//
		this->element(2, 0, 2, 0) =  1.0;
		this->element(2, 0, 0, 2) = -1.0;
		this->element(0, 2, 0, 2) =  1.0;
		this->element(0, 2, 2, 0) = -1.0;
		}
    }
};//----------------------------------------------------------------------------
// 
// Destruktor -> delete &delta
// ===========================
delta_MATRIX::~delta_MATRIX(void)
{
//*** std::cerr<<"delta_MATRIX::Destruktor: Loeschen von 4D delta_MATRIX" << '\n';
};
// ============================================================================
